#include <stdio.h>
#include <stdlib.h>

#define OPERATOR 1
#define VREDNOST 2

void greska(){
	printf("-1");
	exit(EXIT_FAILURE);
}

typedef struct _cvor{
	int vrednost;
	char operator;
	int tip;
	struct _cvor *l;
	struct _cvor *d;
}cvor;

cvor* kreiraj_operator(char *x){
	printf("operator: %s\n", x);
	cvor *c = malloc(sizeof(cvor));
	if(c == NULL)
		greska();
	c->operator = x[0];
	c->tip = OPERATOR;
	c->l = NULL;
	c->d = NULL;
	return c;
}

cvor* kreiraj_vrednost(char *x){
	printf("vrednost: %s\n", x);
	cvor *c = malloc(sizeof(cvor));
	if(c == NULL)
		greska();
	c->vrednost = atoi(x);
	c->tip = VREDNOST;
	c->l = NULL;
	c->d = NULL;
	return c;
}

cvor *ucitaj_cvor(){
	char x[10]; //tmp promenljiva koja ucitava sledecu vrednost na ulazu
	scanf("%s", x);
	//printf("%s\n", x);
	if(x[0] == '+' || x[0] == '-' || x[0] == '*' || x[0] == '/'){
		//operator
		cvor *c = kreiraj_operator(x);
		c->l = ucitaj_cvor();
		c->d = ucitaj_cvor();
		return c;
	}else{
		//vrednost
		return kreiraj_vrednost(x);
	}
}

void ispis(cvor *izraz){
	if(izraz == NULL)
		return;
	if(izraz->tip == VREDNOST)
		printf("%d", izraz->vrednost);
	else if(izraz->tip == OPERATOR){
		printf("(");
		ispis(izraz->l);
		printf("%c", izraz->operator);
		ispis(izraz->d);
		printf(")");
	}
}

cvor *oslobodi(cvor *c){
	if(c == NULL)
		return NULL;
	
	oslobodi(c->l);
	oslobodi(c->d);
	free(c);
	return NULL;
}

int izracunaj(cvor *izraz){
	if(izraz->tip == VREDNOST)
		return izraz->vrednost;
	else if(izraz->tip == OPERATOR){
		switch(izraz->operator){
			case '+': 
				return izracunaj(izraz->l) + izracunaj(izraz->d);
			case '-': 
				return izracunaj(izraz->l) - izracunaj(izraz->d);
			case '*': 
				return izracunaj(izraz->l) * izracunaj(izraz->d);
			case '/': 
				return izracunaj(izraz->l) / izracunaj(izraz->d);
		}
	}
}

int main(){
	cvor *izraz = ucitaj_cvor();
	//test primer: * + 2 3 * - 5 2 / 8 2
	ispis(izraz);
	printf("=%d\n", izracunaj(izraz));
	izraz = oslobodi(izraz);
}