#include <stdio.h>
#include <stdlib.h>
#include "stabla.h"

void greska(){
	printf("-1\n");
	exit(EXIT_FAILURE);
}

cvor* kreiraj_novi(int v){
	cvor *n = malloc(sizeof(cvor));
	if(n == NULL)
		greska();
	
	n->vrednost = v;
	n->l = NULL;
	n->d = NULL;
	return n;
}

cvor* dodaj_u_stablo(cvor *koren, int v){
	//pravimo binarno uredjeno stablo!
	if(koren == NULL) //prazno stablo
		return kreiraj_novi(v);
	
	if(v < koren->vrednost)
		koren->l = dodaj_u_stablo(koren->l, v);
	else
		koren->d = dodaj_u_stablo(koren->d, v);
	return koren;
}

cvor* ucitaj_stablo(){
	//ucitavamo sve dok ne unesemo 0
	int x;
	cvor *s = NULL;
	while(1){
		scanf("%d", &x);
		if(x == 0)
			break;
		
		s = dodaj_u_stablo(s, x);
	}
	return s;
}

cvor* oslobodi(cvor *s){
	//ideja je da oslobodimo levo podstablo,
	//desno podstablo i na kraju koren
	
	//uslov izlaska, ako je stablo prazno
	if(s == NULL)
		return NULL;
	
	oslobodi(s->l);
	oslobodi(s->d);
	free(s);
	return NULL;
}
//LKD - ispis
void ispis(cvor *s){
	if(s == NULL)
		return;
	
	ispis(s->l);
	printf("%d ", s->vrednost);
	ispis(s->d);
}

void ispis_KLD(cvor *s){
	if(s == NULL)
		return;
	
	printf("%d ", s->vrednost);
	ispis_KLD(s->l);
	ispis_KLD(s->d);
}

void ispis_LDK(cvor *s){
	if(s == NULL)
		return;
	
	ispis_LDK(s->l);
	ispis_LDK(s->d);
	printf("%d ", s->vrednost);
}

int dubina(cvor *s){
	if(s == NULL)
		return 0;
	
	int dl = dubina(s->l);
	int dd = dubina(s->d);
	
	return dl > dd ? dl + 1 : dd + 1;
}

int broj_cvorova(cvor *s){
	if(s == NULL)
		return 0;
	else 
		return broj_cvorova(s->l) + broj_cvorova(s->d) + 1;
}

int suma_cvorova(cvor *s){
	if(s == NULL)
		return 0;
	else
		return suma_cvorova(s->l) + suma_cvorova(s->d) + 
			s->vrednost;
}

int broj_listova(cvor *s){
	if(s == NULL)
		return 0;
	else if(s->l == NULL && s->d == NULL)
		return 1;
	else 
		return broj_listova(s->l) + broj_listova(s->d);
}

int suma_listova(cvor *s){
	if(s == NULL)
		return 0;
	else if(s->l == NULL && s->d == NULL)
		return s->vrednost;
	else 
		return suma_listova(s->l) + suma_listova(s->d);
}

int min(cvor *s){
	if(s == NULL)
		return 0;
	
	while(s->l != NULL)
		s = s->l;
	
	return s->vrednost;
}

int max(cvor *s){
	if(s == NULL)
		return 0;
	
	while(s->d != NULL)
		s = s->d;
	
	return s->vrednost;
}

